module diffusion_mod
  use constants
  implicit none
contains

  subroutine calc_diff(temp0,temp)

    real(8),dimension(nx,ny) :: temp0,temp

    integer :: i,j
    real(8) :: a1,a2,a3,a4,aa
    real(8) :: f1,f2,f3,f4,f0

    aa = DD*nu

    do j=1,ny
       do i=1,nx

          f0 = temp0(i,j)

          if(j==1)then
             a1 = aa
             f1 = 1.0d0
          else
             a1 = aa
             f1 = temp0(i,j-1)
          endif

          if(i==1)then
             a2 = aa
             f2 = 1.0d0
          else
             a2 = aa
             f2 = temp0(i-1,j)
          endif

          if(i==nx)then
             a3 = aa
             f3 = 1.0d0
          else
             a3 = aa
             f3 = temp0(i+1,j)
          endif

          if(j==ny)then
             a4 = aa
             f4 = 1.0d0
          else
             a4 = aa
             f4 = temp0(i,j+1)
          endif

          temp(i,j) = f0 &
               + a1*(f1-f0) &
               + a2*(f2-f0) &
               + a3*(f3-f0) &
               + a4*(f4-f0)

       enddo
    enddo

    return
  end subroutine calc_diff

end module diffusion_mod
