include'constants.f90'
include'init.f90'
include'diffusion.f90'
include'output.f90'

program diffusion_v01
  use constants
  use init_mod
  use diffusion_mod
  use output_mod

  implicit none

  real(8),dimension(nx,ny) :: temp,temp0

  integer :: i,j,k,step
  real tarray(2),time0,time1,dtime

  call init(temp)
  call output_gnu(temp,21)

  time0 = dtime(tarray)

  do step=1,fstep

     do j=1,ny
        do i=1,nx
           temp0(i,j) = temp(i,j)
        enddo
     enddo

     call calc_diff(temp0,temp)

  enddo

  time1 = dtime(tarray)
  write (*,'("Computation time t = ",f0.5, " [s]")'), time1-time0
  write (*,'("Performance        = ",f0.5, " [Gflops]")'), Nflops/(time1-time0)/1.0d9

  call output_gnu(temp,22)

end program diffusion_v01
